
// Called by Directory Opus to initialize the script
function OnInit(initData)
{
   DOpus.OutputString("Initializing...");
   // Provide basic information about the Script
   initData.name = "ScriptCommand_jstest";
   initData.desc = "Adds the 'JStest' command to Directory Opus.";
   initData.copyright = "(c) 2014 steje";
   initData.version = "v1.0.1 (js)";
   initData.default_enable = true;

   // Initialise the command that this script adds
   var cmd = initData.AddCommand();
   cmd.name = "JStest";
   cmd.icon = "script";
   cmd.method = "OnJStest";
   cmd.desc = "JStest checks ScriptConfig properties against their default values...";
   cmd.label = "JStest";
   cmd.template = "STRING/O";

   // Set DEBUG flag below to true in order to enable logging messages to the Opus Output Window
   initData.config.DEBUG = true;

   //////////////////////////////////////////////////
   // Create a ScriptConfig property of type VT_BSTR
   initData.config.strScriptVT_BSTR = "VT_BSTR";

   //////////////////////////////////////////////////
   // Create a ScriptConfig property of type VT_I4
   initData.config.iScriptVT_I4 = 255;

   //////////////////////////////////////////////////
   // Create a ScriptConfig property of type VT_BOOL
   initData.config.bScriptVT_BOOL = false;

   //////////////////////////////////////////////////
   // Create a ScriptConfig property of type VT_ARRAY
   initData.config.objScriptVT_ARRAY = ["First","Second","Third","",""];

   DOpus.OutputString("ScriptConfig property objScriptVT_ARRAY is of type:  " + (typeof initData.config.objScriptVT_ARRAY));

   return false;
}


// Implement the Test_Jscript command
function OnJStest(commandData)
{
   var message = "";

   logMsg("");
   logMsg("------------Begin------------");

   //////////////////////////////////////////////////
   // Test the strScriptVT_BSTR ScriptConfig property
   logMsg("");
   message = "ScriptConfig property strScriptVT_BSTR is ";
   logMsg(message + "of type:  " + (typeof Script.config.strScriptVT_BSTR));
   if (Script.config.strScriptVT_BSTR === "VT_BSTR") {
      logMsg(message + "set to:  DEFAULT -> " + Script.config.strScriptVT_BSTR);
   } else {
      logMsg(message + "set to:  CUSTOM -> " + Script.config.strScriptVT_BSTR);
   }

   //////////////////////////////////////////////////
   // Test the iScriptVT_I4 ScriptConfig property
   logMsg("");
   message = "ScriptConfig property iScriptVT_I4 is ";
   logMsg(message + "of type:  " + (typeof Script.config.iScriptVT_I4));
   if (Script.config.iScriptVT_I4 === 255) {
      logMsg(message + "set to:  DEFAULT -> " + Script.config.iScriptVT_I4);
   } else {
      logMsg(message + "set to:  CUSTOM -> " + Script.config.iScriptVT_I4);
   }

   //////////////////////////////////////////////////
   // Test the bScriptVT_BOOL ScriptConfig property
   logMsg("");
   message = "ScriptConfig property bScriptVT_BOOL is ";
   logMsg(message + "of type:  " + (typeof Script.config.bScriptVT_BOOL));
   if (Script.config.bScriptVT_BOOL === false) {
      logMsg(message + "set to:  DEFAULT -> " + Script.config.bScriptVT_BOOL);
   } else {
      logMsg(message + "set to:  CUSTOM -> " + Script.config.bScriptVT_BOOL);
   }

   //////////////////////////////////////////////////
   // Test the objScriptVT_ARRAY ScriptConfig property
   logMsg("");
   message = "ScriptConfig property objScriptVT_ARRAY ";
   var objScriptVT_ARRAY_type = typeof Script.config.objScriptVT_ARRAY;
   logMsg(message + "is of type:  " + objScriptVT_ARRAY_type);
   if (!objScriptVT_ARRAY_type == "unknown")
   {
      for (i =0; i < Script.config.objScriptVT_ARRAY.length; i++)
      {
         if (Script.config.objScriptVT_ARRAY[i] == objGlobalVT_ARRAY[i]) {
            logMsg(message + "values are set to:  [" + i + "]: DEFAULT");
         } else {
            logMsg(message + "values are set to:  [" + i + "]: CUSTOM");
         }
      }
   }

   logMsg("");
   logMsg("-------------End-------------\n");

   return false;
}


// Subroutine to allow toggling of the global VT_BOOL variable to control whether logging is performed or not
function logMsg(message)
{
   if (Script.config.DEBUG) DOpus.OutputString(message);

   return;
}
